@echo off
SETLOCAL ENABLEDELAYEDEXPANSION

set t=%time::=%
set BACKUP_DATE=%date:~6,4%%date:~3,2%%date:~0,2%%t:~0,6%

if not exist "NEW\jre" goto obsdeb

rem deplacement de l'ancienne jre
set /p oldVersion=<jre\version.appup
set /p newVersion=<NEW\jre\version.appup
set backupdir=OLD\jre-%oldVersion: =%-%BACKUP_DATE: =%
echo Update jre version %oldVersion: =% to %newVersion: =% old jre keep in "%backupdir%"
if not exist "OLD" mkdir OLD
move jre "%backupdir%"
move NEW\jre jre

:obsdeb

if not exist "NEW\obsdeb" goto i18n

rem deplacement de l'ancien obsdeb
set /p oldVersion=<obsdeb\version.appup
set /p newVersion=<NEW\obsdeb\version.appup
set backupdir=OLD\obsdeb-%oldVersion: =%-%BACKUP_DATE: =%
echo Update obsdeb version %oldVersion: =% to %newVersion: =% old obsdeb keep in "%backupdir%"
if not exist "OLD" mkdir OLD
move obsdeb "%backupdir%"
move NEW\obsdeb obsdeb

:i18n

if not exist "NEW\i18n" goto help

rem deplacement de l'ancien i18n
set /p oldVersion=<i18n\version.appup
set /p newVersion=<NEW\i18n\version.appup
set backupdir=OLD\i18n-%oldVersion: =%-%BACKUP_DATE: =%
echo Update i18n version %oldVersion: =% to %newVersion: =% old i18n keep in "%backupdir%"
if not exist "OLD" mkdir OLD
move i18n "%backupdir%"
move NEW\i18n i18n

:help

if not exist "NEW\help" goto report

rem deplacement de l'ancien help
set /p oldVersion=<help\version.appup
set /p newVersion=<NEW\help\version.appup
set backupdir=OLD\help-%oldVersion: =%-%BACKUP_DATE: =%
echo Update help version %oldVersion: =% to %newVersion: =% old help keep in "%backupdir%"
if not exist "OLD" mkdir OLD
move help "%backupdir%"
move NEW\help help

:report

if not exist "NEW\report" goto plugins

rem deplacement de l'ancien report
set /p oldVersion=<report\version.appup
set /p newVersion=<NEW\report\version.appup
set backupdir=OLD\report-%oldVersion: =%-%BACKUP_DATE: =%
echo Update report version %oldVersion: =% to %newVersion: =% old report keep in "%backupdir%"
if not exist "OLD" mkdir OLD
move report "%backupdir%"
move NEW\report report

:plugins

if not exist plugins\NEW goto end

rem boucle sur les nouveaux plugins
for /d %%p in (plugins\NEW\*) do (
  set pluginName=%%~np
  set pluginPath=plugins\!pluginName!
  set pluginNewPath=plugins\NEW\!pluginName!
  
  if not exist !pluginNewPath!\version.appup (
    echo !pluginNewPath!\version.appup not found. update aborted.
  ) else (
    set /p newVersion=<!pluginNewPath!\version.appup
    if exist !pluginPath! (
      rem sauvegarde ancien plugin
      set /p oldVersion=<!pluginPath!\version.appup
      set backupdir=plugins\OLD\!pluginName!-!oldVersion!-!BACKUP_DATE!
      echo Update plugin "!pluginName!" version !oldVersion! to !newVersion! old plugin keep in "!backupdir!"
      if not exist plugins\OLD mkdir plugins\OLD
      move "!pluginPath!" "!backupdir!"
    ) else (
      echo Install plugin "!pluginName!" version !newVersion!
    )
    rem install du plugin
    move "!pluginNewPath!" "!pluginPath!"
  )
)

:end

if exist NEW rmdir /Q NEW
if exist plugins\NEW rmdir /Q plugins\NEW

rem move external_backup to root
if exist obsdeb\external_backup.bat move obsdeb\external_backup.bat .
  
ENDLOCAL